#ifndef SIMGA_H
#define SIMGA_H
#include <math.h>
#include <stdio.h>
#include "basicga.h"
#include "tspparams.h"
#include "tsppopulation.h"
#include "graph.h"
        
class Ga : public BasicGa
{
protected:
    TspParams* params;
    Graph graph;
    int numEvals;
public:
    Ga():BasicGa(){
        numEvals = 0;
    }
protected:
    virtual void initParams();
    virtual void parseParam( char* line );
    virtual void load();
        void loadGraph();
    virtual void buildGenome();
    virtual void buildPopulation();
    virtual float eval( Genome* rhs );
};
#endif
