#ifndef TSPGENOME_H
#define TSPGENOME_H
#include <stdlib.h>
#include "params.h"
#include "nstring.h"
#include "genome.h"

class TspGenome : public Genome
{
public:
    TspGenome():Genome(){}
    virtual void randomize();
    virtual void mutate();
    virtual void crossoverWith( Genome* rhs );
    virtual void memetic();
    virtual nString toString();
    virtual bool isvalid(){
        for( int i = 0; i < params->genomeLength; i ++ )
            for( int j = 0; j < params->genomeLength; j ++ )
                if( i != j && bits[i] == bits[j] ) {
                    printf("not valid bits[%i] = bits[%i] = %i\n", i, j, bits[i] );
                    return false;
                }
        return true;
    }
};
#endif
