#include "tsppopulation.h"
void TspPopulation::initialize(){
    printf("tsppopulation::initalize()\n");
    Genome* g[2];
    assert( params->popSize > 0 );
    assert( params->genomeLength > 0 );
    for( int i =0 ; i < params->popSize; i ++ ){
        g[0] = new TspGenome;
        g[1] = new TspGenome;
        g[0]->setParams( params );
        g[0]->initialize();
        g[1]->setParams( params );
        g[1]->initialize();
        g[0]->randomize();
        *g[1] = *g[0];
        genomes[0].Append( g[0] );
        sortedGenomes[0].Append( g[0] );
        bothPopulations.Append( g[0] );

        genomes[1].Append( g[1] );
        sortedGenomes[1].Append( g[1] );
        bothPopulations.Append( g[1] );
    }
}
