#include <fstream>
#include <sstream>
#include "viewer.h"
using namespace std;
Viewer::Viewer(){}
Viewer::~Viewer(){}
void Viewer::run(){
    loadGenFiles();
    int command;
    while( getCommand( command ) ){
        exec( command );
    }
}
void Viewer::loadGenFiles(){
    ifstream file("logs/genlogs");
    char line[1024];
    int generation;
    float fitmin, fitmax, fitavg;
    float mfitmin, mfitmax, mfitavg;
    float fit, mfit;
    char bits[1024];

    while(file.good()){
        file.getline( line, 1024 );
        //printf("parsing %s : ", line );
        if( sscanf( line, "generation %i done", &generation ) == 1 )
            printf("generation: %i\n", generation );
        else if( sscanf( line, "fitnessstats : min: %f max: %f avg: %f\n", &fitmin, &fitmax, &fitavg ) == 3 )
            printf("stats : %f %f %f\n", fitmin, fitmax, fitavg );
        else if( sscanf( line, "mappedfitnessstats : min: %f max: %f avg: %f\n", &mfitmin, &mfitmax, &mfitavg ) == 3 )
            printf("mstats : %f %f %f\n", mfitmin, mfitmax, mfitavg );
        else if( sscanf( line, "f: %f mf: %f %s\n",&fit, &mfit, &bits ) == 3 )
            printf("genome $%f(%f) = %s\n", fit, mfit, bits );
    }
}

void Viewer::showMenu(){
    cout << "(1): show best" << endl;
}
bool Viewer::getCommand( int & i ){
    showMenu();
    char line[1024];
    cin.getline( line, 1024 );
    return sscanf( line, "%i", &i );
}
void Viewer::exec( int a ){
    switch( a ){
        case SHOWBEST: printf("show best\n"); break;
        default : printf("unrecognized command %i\n", a);
    }
}
